#include <stdio.h>
#include <termios.h> 
#include <unistd.h>

#define END_FILE_CHARACTER 0x04 /*UNIX'te Ctrl+D eof karakteridir*/

int linux_getch(void) 
{
  struct termios oldstuff;
  struct termios newstuff;
  int inch;
  
  tcgetattr(STDIN_FILENO, &oldstuff);
  newstuff = oldstuff; /*Eski semboller kaydediliyor*/
  newstuff.c_lflag &= ~(ICANON | ECHO); /* "canonical" ve  "echo" bilgileri sifirlaniyor*/
  tcsetattr(STDIN_FILENO, TCSANOW, &newstuff); /*Yeni semboller belirleniyor*/
  inch = getchar();
  tcsetattr(STDIN_FILENO, TCSANOW, &oldstuff); /*Eski semboller iade ediliyor*/

  if (inch == END_FILE_CHARACTER) {
    inch = EOF;
  }
  return inch;
} 